//+------------------------------------------------------------------+
//|                                             Pesky_Ashi_build.mq4 |
//|                               built from FerruFx_Multi_info+.mq4 |
//|                                                     Ra457 [2010] |
//+------------------------------------------------------------------+


#property indicator_separate_window

#property indicator_minimum 0
#property indicator_maximum 1

#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red

//---- buffers
double UPBuffer[];
double DOWNBuffer[];



// indicators parameters
extern string    Shift_Settings_test_only        = "=== Format: 2007.05.07 00:00 ===";
extern datetime  look_time_shift       = D'2007.05.07 00:00';  // Shift for test if "test" is true
extern double    shift_indicators      =                   0;  // Shift for indicators if "test" is false
extern bool      test                  =               false;

string    MA_Settings           = "=== Moving Average Settings ===";
int       MA_21Period           =           21;  // Fast Moving Average period
int       MA_32Period           =           32;  // Medium Moving Average period
int       MA_64Period           =           64;  // Slow Moving Average period
int       MA_200Period          =          200;  // Slow Moving Average period
int       MAMethod              =     MODE_EMA;  // Moving Average method
int       MAPrice               =  PRICE_CLOSE;  // Moving Average price

string    Pesky_Settings        = "=== Pesky Settings ===";
int       RISK                  =            4;  // 
int       AllBars               =          250;  // 

string    HeikenAshiMTF_Settings= "=== HeikenAshi MTF Settings ===";
int  	    MaMethod			        =            1;
int       MaPeriod              =           20;


double UP_1, UP_2, UP_3, UP_4, UP_5, UP_6, UP_7, UP_8, UP_9, UP_10;
double UP_11, UP_12, UP_13, UP_14, UP_15, UP_16, UP_17, UP_18, UP_19, UP_20;
double UP_21, UP_22, UP_23, UP_24, UP_25, UP_26, UP_27, UP_28, UP_29, UP_30;
double UP_31, UP_32, UP_33, UP_34, UP_35, UP_36, UP_37, UP_38, UP_39, UP_40;
double UP_41, UP_42, UP_43, UP_44, UP_45, UP_46, UP_47, UP_48, UP_49, UP_50;
double UP_51, UP_52, UP_53, UP_54, UP_55, UP_56, UP_57, UP_58, UP_59, UP_60;
double UP_61, UP_62, UP_63, UP_64;

double DOWN_1, DOWN_2, DOWN_3, DOWN_4, DOWN_5, DOWN_6, DOWN_7, DOWN_8, DOWN_9, DOWN_10;
double DOWN_11, DOWN_12, DOWN_13, DOWN_14, DOWN_15, DOWN_16, DOWN_17, DOWN_18, DOWN_19, DOWN_20;
double DOWN_21, DOWN_22, DOWN_23, DOWN_24, DOWN_25, DOWN_26, DOWN_27, DOWN_28, DOWN_29, DOWN_30;
double DOWN_31, DOWN_32, DOWN_33, DOWN_34, DOWN_35, DOWN_36, DOWN_37, DOWN_38, DOWN_39, DOWN_40;
double DOWN_41, DOWN_42, DOWN_43, DOWN_44, DOWN_45, DOWN_46, DOWN_47, DOWN_48, DOWN_49, DOWN_50;
double DOWN_51, DOWN_52, DOWN_53, DOWN_54, DOWN_55, DOWN_56, DOWN_57, DOWN_58, DOWN_59, DOWN_60;
double DOWN_61, DOWN_62, DOWN_63, DOWN_64;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

//---- name for indicator window

   string short_name="   + Open Trade Analysis +";
   IndicatorShortName(short_name);

   SetIndexBuffer(0,UPBuffer);
   SetIndexBuffer(1,DOWNBuffer);

   

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
  int j,total=OrdersTotal();
   for(j=0;j<total;j++)
   {
    OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
   }
   
   color color_common_line = White;
   color color_common_text = White;
   color color_connection;
   
//---- Timeframe and symbol

   string Timeframe = "";
   color color_timeframe=SkyBlue;
   
   double time_frame=Period();
   string symbol=Symbol();
   
   if(time_frame==1) { Timeframe = "M1"; }
   if(time_frame==5) { Timeframe = "M5"; }
   if(time_frame==15) { Timeframe = "M15"; }
   if(time_frame==30) { Timeframe = "M30"; }
   if(time_frame==60) { Timeframe = "H1"; }
   if(time_frame==240) { Timeframe = "H4"; }
   if(time_frame==1440) { Timeframe = "D1"; }
   if(time_frame==10080) { Timeframe = "W1"; }
   if(time_frame==43200) { Timeframe = "MN"; }
    


   
// Timeframes
 
   color color_tf = PaleGoldenrod;

   ObjectCreate("m1", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("m1","M1",7, "Verdana", color_tf);
   ObjectSet("m1", OBJPROP_CORNER, 0);
   ObjectSet("m1", OBJPROP_XDISTANCE, 10);
   ObjectSet("m1", OBJPROP_YDISTANCE, 21);
   
   ObjectCreate("m5", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("m5","M5",7, "Verdana", color_tf);
   ObjectSet("m5", OBJPROP_CORNER, 0);
   ObjectSet("m5", OBJPROP_XDISTANCE, 10);
   ObjectSet("m5", OBJPROP_YDISTANCE, 36);
   
   ObjectCreate("m15", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("m15","M15",7, "Verdana", color_tf);
   ObjectSet("m15", OBJPROP_CORNER, 0);
   ObjectSet("m15", OBJPROP_XDISTANCE, 10);
   ObjectSet("m15", OBJPROP_YDISTANCE, 51);
   
   ObjectCreate("m30", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("m30","M30",7, "Verdana", color_tf);
   ObjectSet("m30", OBJPROP_CORNER, 0);
   ObjectSet("m30", OBJPROP_XDISTANCE, 10);
   ObjectSet("m30", OBJPROP_YDISTANCE, 66);
   
   ObjectCreate("h1", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("h1","H1",7, "Verdana", color_tf);
   ObjectSet("h1", OBJPROP_CORNER, 0);
   ObjectSet("h1", OBJPROP_XDISTANCE, 10);
   ObjectSet("h1", OBJPROP_YDISTANCE, 81);
   
   ObjectCreate("h4", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("h4","H4",7, "Verdana", color_tf);
   ObjectSet("h4", OBJPROP_CORNER, 0);
   ObjectSet("h4", OBJPROP_XDISTANCE, 10);
   ObjectSet("h4", OBJPROP_YDISTANCE, 96);
   
   ObjectCreate("d1", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("d1","D1",7, "Verdana", color_tf);
   ObjectSet("d1", OBJPROP_CORNER, 0);
   ObjectSet("d1", OBJPROP_XDISTANCE, 10);
   ObjectSet("d1", OBJPROP_YDISTANCE, 111);
   
   ObjectCreate("w1", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("w1","W1",7, "Verdana", color_tf);
   ObjectSet("w1", OBJPROP_CORNER, 0);
   ObjectSet("w1", OBJPROP_XDISTANCE, 10);
   ObjectSet("w1", OBJPROP_YDISTANCE, 126);
   
// Shift calculation for indicators (tests only)

   double shift_1, shift_5, shift_15, shift_30, shift_60, shift_240, shift_1440, shift_10080;
   
   if( test == true )
   {
    shift_1=iBarShift(NULL,PERIOD_M1,look_time_shift,false);
    shift_5=iBarShift(NULL,PERIOD_M5,look_time_shift,false);
    shift_15=iBarShift(NULL,PERIOD_M15,look_time_shift,false);
    shift_30=iBarShift(NULL,PERIOD_M30,look_time_shift,false);
    shift_60=iBarShift(NULL,PERIOD_H1,look_time_shift,false);
    shift_240=iBarShift(NULL,PERIOD_H4,look_time_shift,false);
    shift_1440=iBarShift(NULL,PERIOD_D1,look_time_shift,false);
    shift_10080=iBarShift(NULL,PERIOD_W1,look_time_shift,false);
   }
   else
   {
    shift_1=shift_indicators;
    shift_5=shift_indicators;
    shift_15=shift_indicators;
    shift_30=shift_indicators;
    shift_60=shift_indicators;
    shift_240=shift_indicators;
    shift_1440=shift_indicators;
    shift_10080=shift_indicators;
  }
   
// Indicator (Moving Average)

   color color_ind = PowderBlue;
   
   string MA21_Trend_1, MA21_Trend_5, MA21_Trend_15, MA21_Trend_30, MA21_Trend_60, MA21_Trend_240, MA21_Trend_1440, MA21_Trend_10080;
   string MA32_Trend_1, MA32_Trend_5, MA32_Trend_15, MA32_Trend_30, MA32_Trend_60, MA32_Trend_240, MA32_Trend_1440, MA32_Trend_10080;
   string MA64_Trend_1, MA64_Trend_5, MA64_Trend_15, MA64_Trend_30, MA64_Trend_60, MA64_Trend_240, MA64_Trend_1440, MA64_Trend_10080;
   string MA200_Trend_1, MA200_Trend_5, MA200_Trend_15, MA200_Trend_30, MA200_Trend_60, MA200_Trend_240, MA200_Trend_1440, MA200_Trend_10080;
   double x;
   color color_indic;
   
   // 21
   
   double l;
   if(MA_21Period < 10) { l=210; }
   if(MA_21Period >= 10) { l=206; }
   if(MA_21Period >= 100) { l=202; }
   
   ObjectCreate("ma21", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("ma21","MA"+DoubleToStr(MA_21Period,0),9, "Verdana", color_ind);
   ObjectSet("ma21", OBJPROP_CORNER, 0);
   ObjectSet("ma21", OBJPROP_XDISTANCE, l);
   ObjectSet("ma21", OBJPROP_YDISTANCE, 5);

   double MA_21_1_1 = iMA(NULL,PERIOD_M1,MA_21Period,0,MAMethod,MAPrice,shift_1);
   double MA_21_2_1 = iMA(NULL,PERIOD_M1,MA_21Period,0,MAMethod,MAPrice,shift_1+1);
   
   if ((MA_21_1_1 > MA_21_2_1)) { MA21_Trend_1 = "UP"; x = 216; color_indic = Lime; UP_1 = 1; DOWN_1 = 0; }
   if ((MA_21_1_1 < MA_21_2_1)) { MA21_Trend_1 = "DOWN"; x = 206; color_indic = Red; UP_1 = 0; DOWN_1 = 1; }
   ObjectCreate("Trend_MA21_1", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA21_1",MA21_Trend_1,7, "Verdana", color_indic);
   ObjectSet("Trend_MA21_1", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA21_1", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA21_1", OBJPROP_YDISTANCE, 22);
   
   double MA_21_1_5 = iMA(NULL,PERIOD_M5,MA_21Period,0,MAMethod,MAPrice,shift_5);
   double MA_21_2_5 = iMA(NULL,PERIOD_M5,MA_21Period,0,MAMethod,MAPrice,shift_5+1);
   
   if ((MA_21_1_5 > MA_21_2_5)) { MA21_Trend_5 = "UP"; x = 216; color_indic = Lime; UP_2 = 1; DOWN_2 = 0; }
   if ((MA_21_1_5 < MA_21_2_5)) { MA21_Trend_5 = "DOWN"; x = 206; color_indic = Red; UP_2 = 0; DOWN_2 = 1; }
   ObjectCreate("Trend_MA21_5", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA21_5",MA21_Trend_5,7, "Verdana", color_indic);
   ObjectSet("Trend_MA21_5", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA21_5", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA21_5", OBJPROP_YDISTANCE, 37);
   
   double MA_21_1_15 = iMA(NULL,PERIOD_M15,MA_21Period,0,MAMethod,MAPrice,shift_15);
   double MA_21_2_15 = iMA(NULL,PERIOD_M15,MA_21Period,0,MAMethod,MAPrice,shift_15+1);
   
   if ((MA_21_1_15 > MA_21_2_15)) { MA21_Trend_15 = "UP"; x = 216; color_indic = Lime; UP_3 = 1; DOWN_3 = 0; }
   if ((MA_21_1_15 < MA_21_2_15)) { MA21_Trend_15 = "DOWN"; x = 206; color_indic = Red; UP_3 = 0; DOWN_3 = 1; }
   ObjectCreate("Trend_MA21_15", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA21_15",MA21_Trend_15,7, "Verdana", color_indic);
   ObjectSet("Trend_MA21_15", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA21_15", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA21_15", OBJPROP_YDISTANCE, 52);
   
   double MA_21_1_30 = iMA(NULL,PERIOD_M30,MA_21Period,0,MAMethod,MAPrice,shift_30);
   double MA_21_2_30 = iMA(NULL,PERIOD_M30,MA_21Period,0,MAMethod,MAPrice,shift_30+1);
   
   if ((MA_21_1_30 > MA_21_2_30)) { MA21_Trend_30 = "UP"; x = 216; color_indic = Lime; UP_4 = 1; DOWN_4 = 0; }
   if ((MA_21_1_30 < MA_21_2_30)) { MA21_Trend_30 = "DOWN"; x = 206; color_indic = Red; UP_4 = 0; DOWN_4 = 1; }
   ObjectCreate("Trend_MA21_30", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA21_30",MA21_Trend_30,7, "Verdana", color_indic);
   ObjectSet("Trend_MA21_30", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA21_30", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA21_30", OBJPROP_YDISTANCE, 67);
   
   double MA_21_1_60 = iMA(NULL,PERIOD_H1,MA_21Period,0,MAMethod,MAPrice,shift_60);
   double MA_21_2_60 = iMA(NULL,PERIOD_H1,MA_21Period,0,MAMethod,MAPrice,shift_60+1);
   
   if ((MA_21_1_60 > MA_21_2_60)) { MA21_Trend_60 = "UP"; x = 216; color_indic = Lime; UP_5 = 1; DOWN_5 = 0; }
   if ((MA_21_1_60 < MA_21_2_60)) { MA21_Trend_60 = "DOWN"; x = 206; color_indic = Red; UP_5 = 0; DOWN_5 = 1; }
   ObjectCreate("Trend_MA21_60", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA21_60",MA21_Trend_60,7, "Verdana", color_indic);
   ObjectSet("Trend_MA21_60", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA21_60", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA21_60", OBJPROP_YDISTANCE, 82);
   
   double MA_21_1_240 = iMA(NULL,PERIOD_H4,MA_21Period,0,MAMethod,MAPrice,shift_240);
   double MA_21_2_240 = iMA(NULL,PERIOD_H4,MA_21Period,0,MAMethod,MAPrice,shift_240+1);
   
   if ((MA_21_1_240 > MA_21_2_240)) { MA21_Trend_240 = "UP"; x = 216; color_indic = Lime; UP_6 = 1; DOWN_6 = 0; }
   if ((MA_21_1_240 < MA_21_2_240)) { MA21_Trend_240 = "DOWN"; x = 206; color_indic = Red; UP_6 = 0; DOWN_6 = 1; }
   ObjectCreate("Trend_MA21_240", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA21_240",MA21_Trend_240,7, "Verdana", color_indic);
   ObjectSet("Trend_MA21_240", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA21_240", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA21_240", OBJPROP_YDISTANCE, 97);
   
   double MA_21_1_1440 = iMA(NULL,PERIOD_D1,MA_21Period,0,MAMethod,MAPrice,shift_1440);
   double MA_21_2_1440 = iMA(NULL,PERIOD_D1,MA_21Period,0,MAMethod,MAPrice,shift_1440+1);
   
   if ((MA_21_1_1440 > MA_21_2_1440)) { MA21_Trend_1440 = "UP"; x = 216; color_indic = Lime; UP_7 = 1; DOWN_7 = 0; }
   if ((MA_21_1_1440 < MA_21_2_1440)) { MA21_Trend_1440 = "DOWN"; x = 206; color_indic = Red; UP_7 = 0; DOWN_7 = 1; }
   ObjectCreate("Trend_MA21_1440", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA21_1440",MA21_Trend_1440,7, "Verdana", color_indic);
   ObjectSet("Trend_MA21_1440", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA21_1440", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA21_1440", OBJPROP_YDISTANCE, 112);
   
   double MA_21_1_10080 = iMA(NULL,PERIOD_W1,MA_21Period,0,MAMethod,MAPrice,shift_10080);
   double MA_21_2_10080 = iMA(NULL,PERIOD_W1,MA_21Period,0,MAMethod,MAPrice,shift_10080+1);
   
   if ((MA_21_1_10080 > MA_21_2_10080)) { MA21_Trend_10080 = "UP"; x = 216; color_indic = Lime; UP_8 = 1; DOWN_8 = 0; }
   if ((MA_21_1_10080 < MA_21_2_10080)) { MA21_Trend_10080 = "DOWN"; x = 206; color_indic = Red; UP_8 = 0; DOWN_8 = 1; }
   ObjectCreate("Trend_MA21_10080", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA21_10080",MA21_Trend_10080,7, "Verdana", color_indic);
   ObjectSet("Trend_MA21_10080", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA21_10080", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA21_10080", OBJPROP_YDISTANCE, 127);
   
   // 32
   
   double m;
   if(MA_32Period < 10) { m=260; }
   if(MA_32Period >= 10) { m=256; }
   if(MA_32Period >= 100) { m=252; }
   
   ObjectCreate("ma32", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("ma32","MA"+DoubleToStr(MA_32Period,0),9, "Verdana", color_ind);
   ObjectSet("ma32", OBJPROP_CORNER, 0);
   ObjectSet("ma32", OBJPROP_XDISTANCE, m);
   ObjectSet("ma32", OBJPROP_YDISTANCE, 5);
   
   double MA_32_1_1 = iMA(NULL,PERIOD_M1,MA_32Period,0,MAMethod,MAPrice,shift_1);
   double MA_32_2_1 = iMA(NULL,PERIOD_M1,MA_32Period,0,MAMethod,MAPrice,shift_1+1);
   
   if ((MA_32_1_1 > MA_32_2_1)) { MA32_Trend_1 = "UP"; x = 266; color_indic = Lime; UP_9 = 1; DOWN_9 = 0; }
   if ((MA_32_1_1 < MA_32_2_1)) { MA32_Trend_1 = "DOWN"; x = 256; color_indic = Red; UP_9 = 0; DOWN_9 = 1; }
   ObjectCreate("Trend_MA32_1", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA32_1",MA32_Trend_1,7, "Verdana", color_indic);
   ObjectSet("Trend_MA32_1", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA32_1", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA32_1", OBJPROP_YDISTANCE, 22);
   
   double MA_32_1_5 = iMA(NULL,PERIOD_M5,MA_32Period,0,MAMethod,MAPrice,shift_5);
   double MA_32_2_5 = iMA(NULL,PERIOD_M5,MA_32Period,0,MAMethod,MAPrice,shift_5+1);
   
   if ((MA_32_1_5 > MA_32_2_5)) { MA32_Trend_5 = "UP"; x = 266; color_indic = Lime; UP_10 = 1; DOWN_10 = 0; }
   if ((MA_32_1_5 < MA_32_2_5)) { MA32_Trend_5 = "DOWN"; x = 256; color_indic = Red; UP_10 = 0; DOWN_10 = 1; }
   ObjectCreate("Trend_MA32_5", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA32_5",MA32_Trend_5,7, "Verdana", color_indic);
   ObjectSet("Trend_MA32_5", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA32_5", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA32_5", OBJPROP_YDISTANCE, 37);
   
   double MA_32_1_15 = iMA(NULL,PERIOD_M15,MA_32Period,0,MAMethod,MAPrice,shift_15);
   double MA_32_2_15 = iMA(NULL,PERIOD_M15,MA_32Period,0,MAMethod,MAPrice,shift_15+1);
   
   if ((MA_32_1_15 > MA_32_2_15)) { MA32_Trend_15 = "UP"; x = 266; color_indic = Lime; UP_11 = 1; DOWN_11 = 0; }
   if ((MA_32_1_15 < MA_32_2_15)) { MA32_Trend_15 = "DOWN"; x = 256; color_indic = Red; UP_11 = 0; DOWN_11 = 1; }
   ObjectCreate("Trend_MA32_15", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA32_15",MA32_Trend_15,7, "Verdana", color_indic);
   ObjectSet("Trend_MA32_15", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA32_15", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA32_15", OBJPROP_YDISTANCE, 52);
   
   double MA_32_1_30 = iMA(NULL,PERIOD_M30,MA_32Period,0,MAMethod,MAPrice,shift_30);
   double MA_32_2_30 = iMA(NULL,PERIOD_M30,MA_32Period,0,MAMethod,MAPrice,shift_30+1);
   
   if ((MA_32_1_30 > MA_32_2_30)) { MA32_Trend_30 = "UP"; x = 266; color_indic = Lime; UP_12 = 1; DOWN_12 = 0; }
   if ((MA_32_1_30 < MA_32_2_30)) { MA32_Trend_30 = "DOWN"; x = 256; color_indic = Red; UP_12 = 0; DOWN_12 = 1; }
   ObjectCreate("Trend_MA32_30", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA32_30",MA32_Trend_30,7, "Verdana", color_indic);
   ObjectSet("Trend_MA32_30", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA32_30", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA32_30", OBJPROP_YDISTANCE, 67);
   
   double MA_32_1_60 = iMA(NULL,PERIOD_H1,MA_32Period,0,MAMethod,MAPrice,shift_60);
   double MA_32_2_60 = iMA(NULL,PERIOD_H1,MA_32Period,0,MAMethod,MAPrice,shift_60+1);
   
   if ((MA_32_1_60 > MA_32_2_60)) { MA32_Trend_60 = "UP"; x = 266; color_indic = Lime; UP_13 = 1; DOWN_13 = 0; }
   if ((MA_32_1_60 < MA_32_2_60)) { MA32_Trend_60 = "DOWN"; x = 256; color_indic = Red; UP_13 = 0; DOWN_13 = 1; }
   ObjectCreate("Trend_MA32_60", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA32_60",MA32_Trend_60,7, "Verdana", color_indic);
   ObjectSet("Trend_MA32_60", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA32_60", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA32_60", OBJPROP_YDISTANCE, 82);
   
   double MA_32_1_240 = iMA(NULL,PERIOD_H4,MA_32Period,0,MAMethod,MAPrice,shift_240);
   double MA_32_2_240 = iMA(NULL,PERIOD_H4,MA_32Period,0,MAMethod,MAPrice,shift_240+1);
   
   if ((MA_32_1_240 > MA_32_2_240)) { MA32_Trend_240 = "UP"; x = 266; color_indic = Lime; UP_14 = 1; DOWN_14 = 0; }
   if ((MA_32_1_240 < MA_32_2_240)) { MA32_Trend_240 = "DOWN"; x = 256; color_indic = Red; UP_14 = 0; DOWN_14 = 1; }
   ObjectCreate("Trend_MA32_240", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA32_240",MA32_Trend_240,7, "Verdana", color_indic);
   ObjectSet("Trend_MA32_240", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA32_240", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA32_240", OBJPROP_YDISTANCE, 97);
   
   double MA_32_1_1440 = iMA(NULL,PERIOD_D1,MA_32Period,0,MAMethod,MAPrice,shift_1440);
   double MA_32_2_1440 = iMA(NULL,PERIOD_D1,MA_32Period,0,MAMethod,MAPrice,shift_1440+1);
   
   if ((MA_32_1_1440 > MA_32_2_1440)) { MA32_Trend_1440 = "UP"; x = 266; color_indic = Lime; UP_15 = 1; DOWN_15 = 0; }
   if ((MA_32_1_1440 < MA_32_2_1440)) { MA32_Trend_1440 = "DOWN"; x = 256; color_indic = Red; UP_15 = 0; DOWN_15 = 1; }
   ObjectCreate("Trend_MA32_1440", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA32_1440",MA32_Trend_1440,7, "Verdana", color_indic);
   ObjectSet("Trend_MA32_1440", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA32_1440", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA32_1440", OBJPROP_YDISTANCE, 112);
   
   double MA_32_1_10080 = iMA(NULL,PERIOD_W1,MA_32Period,0,MAMethod,MAPrice,shift_10080);
   double MA_32_2_10080 = iMA(NULL,PERIOD_W1,MA_32Period,0,MAMethod,MAPrice,shift_10080+1);
   
   if ((MA_32_1_10080 > MA_32_2_10080)) { MA32_Trend_10080 = "UP"; x = 266; color_indic = Lime; UP_16 = 1; DOWN_16 = 0; }
   if ((MA_32_1_10080 < MA_32_2_10080)) { MA32_Trend_10080 = "DOWN"; x = 256; color_indic = Red; UP_16 = 0; DOWN_16 = 1; }
   ObjectCreate("Trend_MA32_10080", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA32_10080",MA32_Trend_10080,7, "Verdana", color_indic);
   ObjectSet("Trend_MA32_10080", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA32_10080", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA32_10080", OBJPROP_YDISTANCE, 127);
   
   // 64 (Slow) 
   
   double n;
   if(MA_64Period < 10) { n=310; }
   if(MA_64Period >= 10) { n=306; }
   if(MA_64Period >= 100) { n=302; }
   
   ObjectCreate("ma64", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("ma64","MA"+DoubleToStr(MA_64Period,0),9, "Verdana", color_ind);
   ObjectSet("ma64", OBJPROP_CORNER, 0);
   ObjectSet("ma64", OBJPROP_XDISTANCE, n);
   ObjectSet("ma64", OBJPROP_YDISTANCE, 5);
   
   double MA_64_1_1 = iMA(NULL,PERIOD_M1,MA_64Period,0,MAMethod,MAPrice,shift_1);
   double MA_64_2_1 = iMA(NULL,PERIOD_M1,MA_64Period,0,MAMethod,MAPrice,shift_1+1);
   
   if ((MA_64_1_1 > MA_64_2_1)) { MA64_Trend_1 = "UP"; x = 316; color_indic = Lime; UP_17 = 1; DOWN_17 = 0; }
   if ((MA_64_1_1 < MA_64_2_1)) { MA64_Trend_1 = "DOWN"; x = 306; color_indic = Red; UP_17 = 0; DOWN_17 = 1; }
   ObjectCreate("Trend_MA64_1", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA64_1",MA64_Trend_1,7, "Verdana", color_indic);
   ObjectSet("Trend_MA64_1", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA64_1", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA64_1", OBJPROP_YDISTANCE, 22);
   
   double MA_64_1_5 = iMA(NULL,PERIOD_M5,MA_64Period,0,MAMethod,MAPrice,shift_5);
   double MA_64_2_5 = iMA(NULL,PERIOD_M5,MA_64Period,0,MAMethod,MAPrice,shift_5+1);
   
   if ((MA_64_1_5 > MA_64_2_5)) { MA64_Trend_5 = "UP"; x = 316; color_indic = Lime; UP_18 = 1; DOWN_18 = 0; }
   if ((MA_64_1_5 < MA_64_2_5)) { MA64_Trend_5 = "DOWN"; x = 306; color_indic = Red; UP_18 = 0; DOWN_18 = 1; }
   ObjectCreate("Trend_MA64_5", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA64_5",MA64_Trend_5,7, "Verdana", color_indic);
   ObjectSet("Trend_MA64_5", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA64_5", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA64_5", OBJPROP_YDISTANCE, 37);
   
   double MA_64_1_15 = iMA(NULL,PERIOD_M15,MA_64Period,0,MAMethod,MAPrice,shift_15);
   double MA_64_2_15 = iMA(NULL,PERIOD_M15,MA_64Period,0,MAMethod,MAPrice,shift_15+1);
   
   if ((MA_64_1_15 > MA_64_2_15)) { MA64_Trend_15 = "UP"; x = 316; color_indic = Lime; UP_19 = 1; DOWN_19 = 0; }
   if ((MA_64_1_15 < MA_64_2_15)) { MA64_Trend_15 = "DOWN"; x = 306; color_indic = Red; UP_19 = 0; DOWN_19 = 1; }
   ObjectCreate("Trend_MA64_15", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA64_15",MA64_Trend_15,7, "Verdana", color_indic);
   ObjectSet("Trend_MA64_15", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA64_15", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA64_15", OBJPROP_YDISTANCE, 52);
   
   double MA_64_1_30 = iMA(NULL,PERIOD_M30,MA_64Period,0,MAMethod,MAPrice,shift_30);
   double MA_64_2_30 = iMA(NULL,PERIOD_M30,MA_64Period,0,MAMethod,MAPrice,shift_30+1);
   
   if ((MA_64_1_30 > MA_64_2_30)) { MA64_Trend_30 = "UP"; x = 316; color_indic = Lime; UP_20 = 1; DOWN_20 = 0; }
   if ((MA_64_1_30 < MA_64_2_30)) { MA64_Trend_30 = "DOWN"; x = 306; color_indic = Red; UP_20 = 0; DOWN_20 = 1; }
   ObjectCreate("Trend_MA64_30", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA64_30",MA64_Trend_30,7, "Verdana", color_indic);
   ObjectSet("Trend_MA64_30", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA64_30", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA64_30", OBJPROP_YDISTANCE, 67);
   
   double MA_64_1_60 = iMA(NULL,PERIOD_H1,MA_64Period,0,MAMethod,MAPrice,shift_60);
   double MA_64_2_60 = iMA(NULL,PERIOD_H1,MA_64Period,0,MAMethod,MAPrice,shift_60+1);
   
   if ((MA_64_1_60 > MA_64_2_60)) { MA64_Trend_60 = "UP"; x = 316; color_indic = Lime; UP_21 = 1; DOWN_21 = 0; }
   if ((MA_64_1_60 < MA_64_2_60)) { MA64_Trend_60 = "DOWN"; x = 306; color_indic = Red; UP_21 = 0; DOWN_21 = 1; }
   ObjectCreate("Trend_MA64_60", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA64_60",MA64_Trend_60,7, "Verdana", color_indic);
   ObjectSet("Trend_MA64_60", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA64_60", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA64_60", OBJPROP_YDISTANCE, 82);
   
   double MA_64_1_240 = iMA(NULL,PERIOD_H4,MA_64Period,0,MAMethod,MAPrice,shift_240);
   double MA_64_2_240 = iMA(NULL,PERIOD_H4,MA_64Period,0,MAMethod,MAPrice,shift_240+1);
   
   if ((MA_64_1_240 > MA_64_2_240)) { MA64_Trend_240 = "UP"; x = 316; color_indic = Lime; UP_22 = 1; DOWN_22 = 0; }
   if ((MA_64_1_240 < MA_64_2_240)) { MA64_Trend_240 = "DOWN"; x = 306; color_indic = Red; UP_22 = 0; DOWN_22 = 1; }
   ObjectCreate("Trend_MA64_240", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA64_240",MA64_Trend_240,7, "Verdana", color_indic);
   ObjectSet("Trend_MA64_240", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA64_240", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA64_240", OBJPROP_YDISTANCE, 97);
   
   double MA_64_1_1440 = iMA(NULL,PERIOD_D1,MA_64Period,0,MAMethod,MAPrice,shift_1440);
   double MA_64_2_1440 = iMA(NULL,PERIOD_D1,MA_64Period,0,MAMethod,MAPrice,shift_1440+1);
   
   if ((MA_64_1_1440 > MA_64_2_1440)) { MA64_Trend_1440 = "UP"; x = 316; color_indic = Lime; UP_23 = 1; DOWN_23 = 0; }
   if ((MA_64_1_1440 < MA_64_2_1440)) { MA64_Trend_1440 = "DOWN"; x = 306; color_indic = Red; UP_23 = 0; DOWN_23 = 1; }
   ObjectCreate("Trend_MA64_1440", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA64_1440",MA64_Trend_1440,7, "Verdana", color_indic);
   ObjectSet("Trend_MA64_1440", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA64_1440", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA64_1440", OBJPROP_YDISTANCE, 112);
   
   double MA_64_1_10080 = iMA(NULL,PERIOD_W1,MA_64Period,0,MAMethod,MAPrice,shift_10080);
   double MA_64_2_10080 = iMA(NULL,PERIOD_W1,MA_64Period,0,MAMethod,MAPrice,shift_10080+1);
   
   if ((MA_64_1_10080 > MA_64_2_10080)) { MA64_Trend_10080 = "UP"; x = 316; color_indic = Lime; UP_24 = 1; DOWN_24 = 0; }
   if ((MA_64_1_10080 < MA_64_2_10080)) { MA64_Trend_10080 = "DOWN"; x = 306; color_indic = Red; UP_24 = 0; DOWN_24 = 1; }
   ObjectCreate("Trend_MA64_10080", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA64_10080",MA64_Trend_10080,7, "Verdana", color_indic);
   ObjectSet("Trend_MA64_10080", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA64_10080", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA64_10080", OBJPROP_YDISTANCE, 127);

   // 200 (Slowest) 
   
   double h;
   if(MA_200Period < 10) { h=360; }
   if(MA_200Period >= 10) { h=356; }
   if(MA_200Period >= 100) { h=352; }
   
   ObjectCreate("ma200", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("ma200","MA"+DoubleToStr(MA_200Period,0),9, "Verdana", color_ind);
   ObjectSet("ma200", OBJPROP_CORNER, 0);
   ObjectSet("ma200", OBJPROP_XDISTANCE, h);
   ObjectSet("ma200", OBJPROP_YDISTANCE, 5);
   
   double MA_200_1_1 = iMA(NULL,PERIOD_M1,MA_200Period,0,MAMethod,MAPrice,shift_1);
   double MA_200_2_1 = iMA(NULL,PERIOD_M1,MA_200Period,0,MAMethod,MAPrice,shift_1+1);
   
   if ((MA_200_1_1 > MA_200_2_1)) { MA200_Trend_1 = "UP"; x = 366; color_indic = Lime; UP_17 = 1; DOWN_17 = 0; }
   if ((MA_200_1_1 < MA_200_2_1)) { MA200_Trend_1 = "DOWN"; x = 356; color_indic = Red; UP_17 = 0; DOWN_17 = 1; }
   ObjectCreate("Trend_MA200_1", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA200_1",MA200_Trend_1,7, "Verdana", color_indic);
   ObjectSet("Trend_MA200_1", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA200_1", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA200_1", OBJPROP_YDISTANCE, 22);
   
   double MA_200_1_5 = iMA(NULL,PERIOD_M5,MA_200Period,0,MAMethod,MAPrice,shift_5);
   double MA_200_2_5 = iMA(NULL,PERIOD_M5,MA_200Period,0,MAMethod,MAPrice,shift_5+1);
   
   if ((MA_200_1_5 > MA_200_2_5)) { MA200_Trend_5 = "UP"; x = 366; color_indic = Lime; UP_18 = 1; DOWN_18 = 0; }
   if ((MA_200_1_5 < MA_200_2_5)) { MA200_Trend_5 = "DOWN"; x = 356; color_indic = Red; UP_18 = 0; DOWN_18 = 1; }
   ObjectCreate("Trend_MA200_5", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA200_5",MA200_Trend_5,7, "Verdana", color_indic);
   ObjectSet("Trend_MA200_5", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA200_5", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA200_5", OBJPROP_YDISTANCE, 37);
   
   double MA_200_1_15 = iMA(NULL,PERIOD_M15,MA_200Period,0,MAMethod,MAPrice,shift_15);
   double MA_200_2_15 = iMA(NULL,PERIOD_M15,MA_200Period,0,MAMethod,MAPrice,shift_15+1);
   
   if ((MA_200_1_15 > MA_200_2_15)) { MA200_Trend_15 = "UP"; x = 366; color_indic = Lime; UP_19 = 1; DOWN_19 = 0; }
   if ((MA_200_1_15 < MA_200_2_15)) { MA200_Trend_15 = "DOWN"; x = 356; color_indic = Red; UP_19 = 0; DOWN_19 = 1; }
   ObjectCreate("Trend_MA200_15", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA200_15",MA200_Trend_15,7, "Verdana", color_indic);
   ObjectSet("Trend_MA200_15", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA200_15", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA200_15", OBJPROP_YDISTANCE, 52);
   
   double MA_200_1_30 = iMA(NULL,PERIOD_M30,MA_200Period,0,MAMethod,MAPrice,shift_30);
   double MA_200_2_30 = iMA(NULL,PERIOD_M30,MA_200Period,0,MAMethod,MAPrice,shift_30+1);
   
   if ((MA_200_1_30 > MA_200_2_30)) { MA200_Trend_30 = "UP"; x = 366; color_indic = Lime; UP_20 = 1; DOWN_20 = 0; }
   if ((MA_200_1_30 < MA_200_2_30)) { MA200_Trend_30 = "DOWN"; x = 356; color_indic = Red; UP_20 = 0; DOWN_20 = 1; }
   ObjectCreate("Trend_MA200_30", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA200_30",MA200_Trend_30,7, "Verdana", color_indic);
   ObjectSet("Trend_MA200_30", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA200_30", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA200_30", OBJPROP_YDISTANCE, 67);
   
   double MA_200_1_60 = iMA(NULL,PERIOD_H1,MA_200Period,0,MAMethod,MAPrice,shift_60);
   double MA_200_2_60 = iMA(NULL,PERIOD_H1,MA_200Period,0,MAMethod,MAPrice,shift_60+1);
   
   if ((MA_200_1_60 > MA_200_2_60)) { MA200_Trend_60 = "UP"; x = 366; color_indic = Lime; UP_21 = 1; DOWN_21 = 0; }
   if ((MA_200_1_60 < MA_200_2_60)) { MA200_Trend_60 = "DOWN"; x = 356; color_indic = Red; UP_21 = 0; DOWN_21 = 1; }
   ObjectCreate("Trend_MA200_60", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA200_60",MA200_Trend_60,7, "Verdana", color_indic);
   ObjectSet("Trend_MA200_60", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA200_60", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA200_60", OBJPROP_YDISTANCE, 82);
   
   double MA_200_1_240 = iMA(NULL,PERIOD_H4,MA_200Period,0,MAMethod,MAPrice,shift_240);
   double MA_200_2_240 = iMA(NULL,PERIOD_H4,MA_200Period,0,MAMethod,MAPrice,shift_240+1);
   
   if ((MA_200_1_240 > MA_200_2_240)) { MA200_Trend_240 = "UP"; x = 366; color_indic = Lime; UP_22 = 1; DOWN_22 = 0; }
   if ((MA_200_1_240 < MA_200_2_240)) { MA200_Trend_240 = "DOWN"; x = 356; color_indic = Red; UP_22 = 0; DOWN_22 = 1; }
   ObjectCreate("Trend_MA200_240", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA200_240",MA200_Trend_240,7, "Verdana", color_indic);
   ObjectSet("Trend_MA200_240", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA200_240", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA200_240", OBJPROP_YDISTANCE, 97);
   
   double MA_200_1_1440 = iMA(NULL,PERIOD_D1,MA_200Period,0,MAMethod,MAPrice,shift_1440);
   double MA_200_2_1440 = iMA(NULL,PERIOD_D1,MA_200Period,0,MAMethod,MAPrice,shift_1440+1);
   
   if ((MA_200_1_1440 > MA_200_2_1440)) { MA200_Trend_1440 = "UP"; x = 366; color_indic = Lime; UP_23 = 1; DOWN_23 = 0; }
   if ((MA_200_1_1440 < MA_200_2_1440)) { MA200_Trend_1440 = "DOWN"; x = 356; color_indic = Red; UP_23 = 0; DOWN_23 = 1; }
   ObjectCreate("Trend_MA200_1440", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA200_1440",MA200_Trend_1440,7, "Verdana", color_indic);
   ObjectSet("Trend_MA200_1440", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA200_1440", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA200_1440", OBJPROP_YDISTANCE, 112);
   
   double MA_200_1_10080 = iMA(NULL,PERIOD_W1,MA_200Period,0,MAMethod,MAPrice,shift_10080);
   double MA_200_2_10080 = iMA(NULL,PERIOD_W1,MA_200Period,0,MAMethod,MAPrice,shift_10080+1);
   
   if ((MA_200_1_10080 > MA_200_2_10080)) { MA200_Trend_10080 = "UP"; x = 366; color_indic = Lime; UP_24 = 1; DOWN_24 = 0; }
   if ((MA_200_1_10080 < MA_200_2_10080)) { MA200_Trend_10080 = "DOWN"; x = 356; color_indic = Red; UP_24 = 0; DOWN_24 = 1; }
   ObjectCreate("Trend_MA200_10080", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_MA200_10080",MA200_Trend_10080,7, "Verdana", color_indic);
   ObjectSet("Trend_MA200_10080", OBJPROP_CORNER, 0);
   ObjectSet("Trend_MA200_10080", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_MA200_10080", OBJPROP_YDISTANCE, 127);
         
// Pesky

   ObjectCreate("Pesky", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Pesky","Pesky",9, "Verdana", color_ind);
   ObjectSet("Pesky", OBJPROP_CORNER, 0);
   ObjectSet("Pesky", OBJPROP_XDISTANCE, 405);
   ObjectSet("Pesky", OBJPROP_YDISTANCE, 5);
   
   string Pesky_Trend_1, Pesky_Trend_5, Pesky_Trend_15, Pesky_Trend_30, Pesky_Trend_60, Pesky_Trend_240, Pesky_Trend_1440, Pesky_Trend_10080;
   
   
   double Pesky_m_1=iCustom(NULL,PERIOD_M1, "PerkyAsctrend1", RISK, AllBars,0,shift_1);
   
   if ((Pesky_m_1 > 0)) { Pesky_Trend_1 = "UP"; x = 416; color_indic = Lime; UP_33 = 1; DOWN_33 = 0; }
   if ((Pesky_m_1 < 0)) { Pesky_Trend_1 = "DOWN"; x = 406; color_indic = Red; UP_33 = 0; DOWN_33 = 1; }
   ObjectCreate("Trend_Pesky_1", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_Pesky_1",Pesky_Trend_1,7, "Verdana", color_indic);
   ObjectSet("Trend_Pesky_1", OBJPROP_CORNER, 0);
   ObjectSet("Trend_Pesky_1", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_Pesky_1", OBJPROP_YDISTANCE, 22);
   
   double Pesky_m_5=iCustom(NULL,PERIOD_M5, "PerkyAsctrend1", RISK, AllBars,0,shift_5);
   
   if ((Pesky_m_5 > 0)) { Pesky_Trend_5 = "UP"; x = 416; color_indic = Lime; UP_34 = 1; DOWN_34 = 0; }
   if ((Pesky_m_5 < 0)) { Pesky_Trend_5 = "DOWN"; x = 406; color_indic = Red; UP_34 = 0; DOWN_34 = 1; }
   ObjectCreate("Trend_Pesky_5", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_Pesky_5",Pesky_Trend_5,7, "Verdana", color_indic);
   ObjectSet("Trend_Pesky_5", OBJPROP_CORNER, 0);
   ObjectSet("Trend_Pesky_5", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_Pesky_5", OBJPROP_YDISTANCE, 37);
   
   double Pesky_m_15=iCustom(NULL,PERIOD_M15, "PerkyAsctrend1", RISK, AllBars,0,shift_15);

   
   if ((Pesky_m_15 > 0)) { Pesky_Trend_15 = "UP"; x = 416; color_indic = Lime; UP_35 = 1; DOWN_35 = 0; }
   if ((Pesky_m_15 < 0)) { Pesky_Trend_15 = "DOWN"; x = 406; color_indic = Red; UP_35 = 0; DOWN_35 = 1; }
   ObjectCreate("Trend_Pesky_15", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_Pesky_15",Pesky_Trend_15,7, "Verdana", color_indic);
   ObjectSet("Trend_Pesky_15", OBJPROP_CORNER, 0);
   ObjectSet("Trend_Pesky_15", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_Pesky_15", OBJPROP_YDISTANCE, 52);
   
   double Pesky_m_30=iCustom(NULL,PERIOD_M30, "PerkyAsctrend1", RISK, AllBars,0,shift_30);
   
   if ((Pesky_m_30 > 0)) { Pesky_Trend_30 = "UP"; x = 416; color_indic = Lime; UP_36 = 1; DOWN_36 = 0; }
   if ((Pesky_m_30 < 0)) { Pesky_Trend_30 = "DOWN"; x = 406; color_indic = Red; UP_36 = 0; DOWN_36 = 1; }
   ObjectCreate("Trend_Pesky_30", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_Pesky_30",Pesky_Trend_30,7, "Verdana", color_indic);
   ObjectSet("Trend_Pesky_30", OBJPROP_CORNER, 0);
   ObjectSet("Trend_Pesky_30", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_Pesky_30", OBJPROP_YDISTANCE, 67);
   
   double Pesky_m_60=iCustom(NULL,PERIOD_H1, "PerkyAsctrend1", RISK, AllBars,0,shift_60);
   
   if ((Pesky_m_60 > 0)) { Pesky_Trend_60 = "UP"; x = 416; color_indic = Lime; UP_37 = 1; DOWN_37 = 0; }
   if ((Pesky_m_60 < 0)) { Pesky_Trend_60 = "DOWN"; x = 406; color_indic = Red; UP_37 = 0; DOWN_37 = 1; }
   ObjectCreate("Trend_Pesky_60", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_Pesky_60",Pesky_Trend_60,7, "Verdana", color_indic);
   ObjectSet("Trend_Pesky_60", OBJPROP_CORNER, 0);
   ObjectSet("Trend_Pesky_60", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_Pesky_60", OBJPROP_YDISTANCE, 82);
   
   double Pesky_m_240=iCustom(NULL,PERIOD_H4, "PerkyAsctrend1", RISK, AllBars,0,shift_240);
   
   if ((Pesky_m_240 > 0)) { Pesky_Trend_240 = "UP"; x = 416; color_indic = Lime; UP_38 = 1; DOWN_38 = 0; }
   if ((Pesky_m_240 < 0)) { Pesky_Trend_240 = "DOWN"; x = 406; color_indic = Red; UP_38 = 0; DOWN_38 = 1; }
   ObjectCreate("Trend_Pesky_240", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_Pesky_240",Pesky_Trend_240,7, "Verdana", color_indic);
   ObjectSet("Trend_Pesky_240", OBJPROP_CORNER, 0);
   ObjectSet("Trend_Pesky_240", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_Pesky_240", OBJPROP_YDISTANCE, 97);
   
   double Pesky_m_1440=iCustom(NULL,PERIOD_M15, "PerkyAsctrend1", RISK, AllBars,0,shift_1440);
   
   if ((Pesky_m_1440 > 0)) { Pesky_Trend_1440 = "UP"; x = 416; color_indic = Lime; UP_39 = 1; DOWN_39 = 0; }
   if ((Pesky_m_1440 < 0)) { Pesky_Trend_1440 = "DOWN"; x = 406; color_indic = Red; UP_39 = 0; DOWN_39 = 1; }
   ObjectCreate("Trend_Pesky_1440", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_Pesky_1440",Pesky_Trend_1440,7, "Verdana", color_indic);
   ObjectSet("Trend_Pesky_1440", OBJPROP_CORNER, 0);
   ObjectSet("Trend_Pesky_1440", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_Pesky_1440", OBJPROP_YDISTANCE, 112);
   
   double Pesky_m_10080=iCustom(NULL,PERIOD_M15, "PerkyAsctrend1", RISK, AllBars,0,shift_10080);
   
   if ((Pesky_m_10080 > 0)) { Pesky_Trend_10080 = "UP"; x = 416; color_indic = Lime; UP_40 = 1; DOWN_40 = 0; }
   if ((Pesky_m_10080 < 0)) { Pesky_Trend_10080 = "DOWN"; x = 406; color_indic = Red; UP_40 = 0; DOWN_40 = 1; }
   ObjectCreate("Trend_Pesky_10080", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_Pesky_10080",Pesky_Trend_10080,7, "Verdana", color_indic);
   ObjectSet("Trend_Pesky_10080", OBJPROP_CORNER, 0);
   ObjectSet("Trend_Pesky_10080", OBJPROP_XDISTANCE, x);
   ObjectSet("Trend_Pesky_10080", OBJPROP_YDISTANCE, 127);
   
// Indicator (Heiken)

   ObjectCreate("HA", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("HA","HA",9, "Verdana", color_ind);
   ObjectSet("HA", OBJPROP_CORNER, 0);
   ObjectSet("HA", OBJPROP_XDISTANCE, 453);
   ObjectSet("HA", OBJPROP_YDISTANCE, 5);

   string HA_Trend_1, HA_Trend_5, HA_Trend_15, HA_Trend_30, HA_Trend_60, HA_Trend_240, HA_Trend_1440, HA_Trend_10080;
   
   double HA_1_1=iCustom(NULL,PERIOD_M1,"Heiken MTF",MaMethod,MaPeriod,shift_1);
   double HA_2_1=iCustom(NULL,PERIOD_M1,"Heiken MTF",MaMethod,MaPeriod,shift_1+1);
   
   if ((HA_1_1 > HA_2_1)) { HA_Trend_1 = "UP"; x = 466; color_indic = Lime; UP_41 = 1; DOWN_41 = 0; }
   if ((HA_1_1 < HA_2_1)) { HA_Trend_1 = "DOWN"; x = 456; color_indic = Lime; UP_41 = 0; DOWN_41 = 1; }
   ObjectCreate("Trend_HA_1", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_HA_1",HA_Trend_1,7, "Verdana", color_indic);
   ObjectSet("Trend_HA_1", OBJPROP_CORNER, 0);
   ObjectSet("Trend_HA_1", OBJPROP_XDISTANCE, 453);
   ObjectSet("Trend_HA_1", OBJPROP_YDISTANCE, 22);
   
   double HA_1_5=iCustom(NULL,PERIOD_M5,"Heiken MTF",MaMethod,MaPeriod,shift_5);
   double HA_2_5=iCustom(NULL,PERIOD_M5,"Heiken MTF",MaMethod,MaPeriod,shift_5+1);
   
   if ((HA_1_5 > HA_2_5)) { HA_Trend_5 = "UP"; x = 466; color_indic = Lime; UP_42 = 1; DOWN_42 = 0; }
   if ((HA_1_5 < HA_2_5)) { HA_Trend_5 = "DOWN"; x = 456; color_indic = Lime; UP_41 = 0; DOWN_41 = 1; }
   ObjectCreate("Trend_HA_5", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_HA_5",HA_Trend_5,7, "Verdana", color_indic);
   ObjectSet("Trend_HA_5", OBJPROP_CORNER, 0);
   ObjectSet("Trend_HA_5", OBJPROP_XDISTANCE, 453);
   ObjectSet("Trend_HA_5", OBJPROP_YDISTANCE, 37);
   
   double HA_1_15=iCustom(NULL,PERIOD_M15,"Heiken MTF",MaMethod,MaPeriod,shift_15);
   double HA_2_15=iCustom(NULL,PERIOD_M15,"Heiken MTF",MaMethod,MaPeriod,shift_15+1);
   
   if ((HA_1_15 > HA_2_15)) { HA_Trend_15 = "UP"; x = 466; color_indic = Lime; UP_43 = 1; DOWN_43 = 0; }
   if ((HA_1_15 < HA_2_15)) { HA_Trend_15 = "DOWN"; x = 456; color_indic = Lime; UP_41 = 0; DOWN_41 = 1; }
   ObjectCreate("Trend_HA_15", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_HA_15",HA_Trend_15,7, "Verdana", color_indic);
   ObjectSet("Trend_HA_15", OBJPROP_CORNER, 0);
   ObjectSet("Trend_HA_15", OBJPROP_XDISTANCE, 453);
   ObjectSet("Trend_HA_15", OBJPROP_YDISTANCE, 52);
   
   double HA_1_30=iCustom(NULL,PERIOD_M30,"Heiken MTF",MaMethod,MaPeriod,shift_30);
   double HA_2_30=iCustom(NULL,PERIOD_M30,"Heiken MTF",MaMethod,MaPeriod,shift_30+1);
   
   if ((HA_1_30 > HA_2_30)) { HA_Trend_30 = "UP"; x = 466; color_indic = Lime; UP_44 = 1; DOWN_44 = 0; }
   if ((HA_1_30 < HA_2_30)) { HA_Trend_30 = "DOWN"; x = 456; color_indic = Lime; UP_41 = 0; DOWN_41 = 1; }
   ObjectCreate("Trend_HA_30", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_HA_30",HA_Trend_30,7, "Verdana", color_indic);
   ObjectSet("Trend_HA_30", OBJPROP_CORNER, 0);
   ObjectSet("Trend_HA_30", OBJPROP_XDISTANCE, 453);
   ObjectSet("Trend_HA_30", OBJPROP_YDISTANCE, 67);
   
   double HA_1_60=iCustom(NULL,PERIOD_H1,"Heiken MTF",MaMethod,MaPeriod,shift_60);
   double HA_2_60=iCustom(NULL,PERIOD_H1,"Heiken MTF",MaMethod,MaPeriod,shift_60+1);
   
   if ((HA_1_60 > HA_2_60)) { HA_Trend_60 = "UP"; x = 466; color_indic = Lime; UP_45 = 1; DOWN_45 = 0; }
   if ((HA_1_60 < HA_2_60)) { HA_Trend_60 = "DOWN"; x = 456; color_indic = Lime; UP_41 = 0; DOWN_41 = 1; }   
   ObjectCreate("Trend_HA_60", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_HA_60",HA_Trend_60,7, "Verdana", color_indic);
   ObjectSet("Trend_HA_60", OBJPROP_CORNER, 0);
   ObjectSet("Trend_HA_60", OBJPROP_XDISTANCE, 453);
   ObjectSet("Trend_HA_60", OBJPROP_YDISTANCE, 82);
   
   double HA_1_240=iCustom(NULL,PERIOD_H4,"Heiken MTF",MaMethod,MaPeriod,shift_240);
   double HA_2_240=iCustom(NULL,PERIOD_H4,"Heiken MTF",MaMethod,MaPeriod,shift_240+1);
   
   if ((HA_1_240 > HA_2_240)) { HA_Trend_240 = "UP"; x = 466; color_indic = Lime; UP_46 = 1; DOWN_46 = 0; }
   if ((HA_1_240 < HA_2_240)) { HA_Trend_240 = "DOWN"; x = 456; color_indic = Lime; UP_41 = 0; DOWN_41 = 1; }   
   ObjectCreate("Trend_HA_240", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_HA_240",HA_Trend_240,7, "Verdana", color_indic);
   ObjectSet("Trend_HA_240", OBJPROP_CORNER, 0);
   ObjectSet("Trend_HA_240", OBJPROP_XDISTANCE, 453);
   ObjectSet("Trend_HA_240", OBJPROP_YDISTANCE, 97);
   
   double HA_1_1440=iCustom(NULL,PERIOD_D1,"Heiken MTF",MaMethod,MaPeriod,shift_1440);
   double HA_2_1440=iCustom(NULL,PERIOD_D1,"Heiken MTF",MaMethod,MaPeriod,shift_1440+1);
   
   if ((HA_1_1440 > HA_2_1440)) { HA_Trend_1440 = "UP"; x = 466; color_indic = Lime; UP_47 = 1; DOWN_47 = 0; }  
   if ((HA_1_1440 < HA_2_1440)) { HA_Trend_1440 = "DOWN"; x = 456; color_indic = Lime; UP_41 = 0; DOWN_41 = 1; }   
   ObjectCreate("Trend_HA_1440", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_HA_1440",HA_Trend_1440,7, "Verdana", color_indic);
   ObjectSet("Trend_HA_1440", OBJPROP_CORNER, 0);
   ObjectSet("Trend_HA_1440", OBJPROP_XDISTANCE, 453);
   ObjectSet("Trend_HA_1440", OBJPROP_YDISTANCE, 112);
   
   double HA_1_10080=iCustom(NULL,PERIOD_W1,"Heiken MTF",MaMethod,MaPeriod,shift_10080);
   double HA_2_10080=iCustom(NULL,PERIOD_W1,"Heiken MTF",MaMethod,MaPeriod,shift_10080+1);
   
   if ((HA_1_10080 > HA_2_10080)) { HA_Trend_10080 = "UP"; x = 466; color_indic = Lime; UP_48 = 1; DOWN_48 = 0; }
   if ((HA_1_10080 < HA_2_10080)) { HA_Trend_10080 = "DOWN"; x = 456; color_indic = Lime; UP_41 = 0; DOWN_41 = 1; }   
   ObjectCreate("Trend_HA_10080", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("Trend_HA_10080",HA_Trend_10080,7, "Verdana", color_indic);
   ObjectSet("Trend_HA_10080", OBJPROP_CORNER, 0);
   ObjectSet("Trend_HA_10080", OBJPROP_XDISTANCE, 453);
   ObjectSet("Trend_HA_10080", OBJPROP_YDISTANCE, 127);

   
 
   
//Calculation of the trend

   double Trend_UP = UP_1 + UP_2 + UP_3 + UP_4 + UP_5 + UP_6 + UP_7 + UP_8 + UP_9 + UP_10
                                + UP_11 + UP_12 + UP_13 + UP_14 + UP_15 + UP_16 + UP_17 + UP_18 + UP_19 + UP_20
                                + UP_21 + UP_22 + UP_23 + UP_24 + UP_25 + UP_26 + UP_27 + UP_28 + UP_29 + UP_30
                                + UP_31 + UP_32 + UP_33 + UP_34 + UP_35 + UP_36 + UP_37 + UP_38 + UP_39 + UP_40
                                + UP_41 + UP_42 + UP_43 + UP_44 + UP_45 + UP_46 + UP_47 + UP_48 + UP_49 + UP_50
                                + UP_51 + UP_52 + UP_53 + UP_54 + UP_55 + UP_56 + UP_57 + UP_58 + UP_59 + UP_60
                                + UP_61 + UP_62 + UP_63 + UP_64;
   double Trend_DOWN = DOWN_1 + DOWN_2 + DOWN_3 + DOWN_4 + DOWN_5 + DOWN_6 + DOWN_7 + DOWN_8 + DOWN_9 + DOWN_10
                                  + DOWN_11 + DOWN_12 + DOWN_13 + DOWN_14 + DOWN_15 + DOWN_16 + DOWN_17 + DOWN_18 + DOWN_19 + DOWN_20
                                  + DOWN_21 + DOWN_22 + DOWN_23 + DOWN_24 + DOWN_25 + DOWN_26 + DOWN_27 + DOWN_28 + DOWN_29 + DOWN_30
                                  + DOWN_31 + DOWN_32 + DOWN_33 + DOWN_34 + DOWN_35 + DOWN_36 + DOWN_37 + DOWN_38 + DOWN_39 + DOWN_40
                                  + DOWN_41 + DOWN_42 + DOWN_43 + DOWN_44 + DOWN_45 + DOWN_46 + DOWN_47 + DOWN_48 + DOWN_49 + DOWN_50
                                  + DOWN_51 + DOWN_52 + DOWN_53 + DOWN_54 + DOWN_55 + DOWN_56 + DOWN_57 + DOWN_58 + DOWN_59 + DOWN_60
                                  + DOWN_61 + DOWN_62 + DOWN_63 + DOWN_64;
                                  
   UPBuffer[0] = Trend_UP;
   DOWNBuffer[0] = Trend_DOWN;
   
      
   return(0);
  }